static	char	sccsid[]="%Z% %M% %I% %E% %U%";
/*******************************************************/
/* <clexescr.c>                                        */
/*      script execute process                         */
/*******************************************************/

#include "colmn.h"

extern condList  CLcList;		/* 񃊃Xg */
extern CLPRTBL   *pGLprocTable;
extern CLPRTBL   *pCLprocTable;
extern GlobalCt  *pGlobTable;
extern CLCOMMON  CLcommon;
extern int giOptions[];
extern tdtLruScrHead *tpLruScrHeadImp;
extern tdtLruScrHead *tpLruScrHead;
/*extern FILE *gStdio[];*/
extern M_FILE *stdios[];
extern M_FILE *m_stdin,*m_stdout,*m_stderr;

#if 0
static MCAT CLcList_mcat={'M','C',512,0,0,0,NULL,0};
#endif

typedef struct {
	M_FILE **stdiow;
	M_FILE *fpi;
	M_FILE *fpo;
	int nparm;
	int here_doc;
	int pflag2_opt;
	ParList2 *parl;		/* heredocEOFi[ */
	char *mode;
	int std_err;
} tdtREDIRECT_CTL;

/****************************************************/
/*	01 _print_script_start							*/
/****************************************************/
static void _print_script_start(scrname)
char *scrname;
{
	static char *fmt="***** Script Name ( %s ) *****";

	PRDBGOUTL1(1,fmt,scrname);
}

/****************************************************/
/*	02 _print_end_script							*/
/****************************************************/
static void _print_end_script(scrname,errcode)
char *scrname;
int errcode;
{
	static char *fmt="----- End Script ( %s )  nofree no=%d ret=%d -----";

	PRDBGOUTL3(1,fmt,scrname,Nofree(0),errcode);	/* Nofree(0)scrprctJɎ擾 */
}

/**************************************************************/
/* cl_execute_script                                          */
/* function; Execute specified Script                         */
/**************************************************************/
int cl_execute_script()
{
	static char *_fn_="cl_execute_script";
	ScrPrCT *scrprct = ( ScrPrCT *)NULL;
	ProcCT  *procct  = ( ProcCT *)NULL ;
	int rc,ret,i;
	char wrk[Pr_NM_MAX+1];
	Leaf *nodeleaf;
	M_FILE *fp;
	tdtInfoParm *pRetInfo;
	tdtStackObj *pSO;

DEBUGOUTL1(110,"%s:Enter",_fn_);

	scrprct = cl_search_src_ct(); /* Search current script control table */
	if (!scrprct) return ECL_SYSTEM_ERROR;
DEBUGOUTL2(110,"%s: enter scrprct=%08x",_fn_,scrprct);

	procct = cl_search_proc_ct(); /* Search current proc control table */
	if (procct == NULL) return ECL_SYSTEM_ERROR;
DEBUGOUTL2(110,"%s: enter procct=%08x",_fn_,procct);

	if (cmn_chk_stat(SCR_PR,&procct->ptype)) {
		ret = cl_node_control(procct->ProcTop,procct);
		procct = cl_search_proc_ct();
		if (!procct) return ECL_SYSTEM_ERROR;
DEBUGOUTL4(110,"%s: ret=%d exception=%08x ret node procct=%08x",_fn_,ret,pGlobTable->exception,procct);
		if (cmn_chk_stat(RET_PR,&procct->ptype)){
/*
if (procct->Nodeleaf) printf("%s:End scrprct=%08x procct=%08x\n",_fn_,scrprct,procct);
*/
			cl_set_scr_const_ct(scrprct,procct->Nodeleaf,NULL);
			/* 2022.4.15 */
/*
printf("%s: procct=%08x(%s) call cl_heredoc_skip_to_eof.\n",_fn_,procct,procct->ProcNM);
*/
			pRetInfo = procct->Retval;
			rc = cl_er_lk_proc_ct();	/* Erase ProcCt */
			if(rc == -1) {
				return ECL_SYSTEM_ERROR;
			}
			else if(rc == -2) {
				strnzcpy(wrk,scrprct->pId,sizeof(wrk)-1);	/* scrprctJƃXNvgȂ̂łŕۑ */
				/* 2022.4.26 */
/*
printf("%s: scrprct=%08x(%s) call cl_heredoc_skip_to_eof.\n",_fn_,scrprct,scrprct->pId);
*/
				/* 2021.8.25 */
/*
printf("%s: try_level_save=%d\n",_fn_,scrprct->try_level_save);
*/
				pGlobTable->try_level = scrprct->try_level_save;
				rc = cl_er_lk_scr_pr_ct();
/*
printf("%s: cl_er_lk_scr_pr_ct rc =%d\n",_fn_,rc);
*/
				if (rc == -1)
					return ECL_SYSTEM_ERROR;
				else if (rc == -2) {
					cmn_set_stat(SCR_ED,&pCLprocTable->ScrSt,L_ON);
				}
				else {
					_print_end_script(wrk,pGlobTable->error);
				}
			}
			if (scrprct = cl_search_src_ct()) {
				procct = cl_search_proc_ct();
			}
			rc = 0;
		}
	}
	else {
		/* 2021.7.22 */
		if (pGlobTable->try_level>0 && pGlobTable->exception) {
			rc = cl_er_lk_proc_ct();	/* Erase ProcCt */
			return 0;
		}
		ret = cl_func_process(procct);
		if (ret) {
/*
printf("%s:cl_func_process ret=%d\n",_fn_,ret);
*/
			pGlobTable->error = ret;
			if (!pGlobTable->exception)
				pGlobTable->exception = cl_mk_exception_code(ETC_EXCEPTION,ret);
			ret = 0;
		}
	}
	return ret;
}

/**************************************************************/
/* cl_exe_scr_name_check                                      */
/**************************************************************/
int cl_exe_scr_name_check(sc_nam,pr_nam)
ParList *pr_nam,*sc_nam;
{
	static char *_fname_="cl_exe_scr_name_check";
	int  len,n;
	char *name,*pn;

	/* parameter check */
	if (!(name=sc_nam->par)) {
		ERROROUT1("%s: script name is NULL!",_fname_);
		return ECL_SYSTEM_ERROR;
	}
	if (cl_chk_file_name(sc_nam->par,sc_nam->parlen)) {
		/* %s: XNvg[%s]słB */
		ERROROUT3(FORMAT(113),_fname_,FORMAT(119),sc_nam->par);
		return ECL_SCRIPT_ERROR;
	}
	return 0;
}

/****************************************************************/
/* cl_exe_scr_init												*/
/* function; Read specified Script From DB						*/
/*  : proc	: EXECR}hsĂproc				*/
/****************************************************************/
int cl_exe_scr_init(sc_nam,pr_nam,leaf,proc,nam_pos)
ParList *pr_nam,*sc_nam;
Leaf   *leaf;
ProcCT *proc;
int    nam_pos;
{
	int rc,len,n,l;
	char *name,*p,*scrname;

DEBUGOUTL3(110,"cl_exe_scr_init:Enter leaf=%08x proc=%08x nam_pos=%d",leaf,proc,nam_pos);

	errmsg_clear();
	if (!(rc = cl_exe_scr_name_check(sc_nam,pr_nam))) {
		rc = cl_exe_scr_file_init(sc_nam->par,pr_nam->par,leaf,proc,nam_pos);
		if (rc == ECL_NOT_FOUND_PROC) {
			if (!pr_nam->par || !pr_nam->parlen) rc = 0;
		}
	}
DEBUGOUTL1(110,"cl_exe_scr_init:Exit rc=%d",rc);
	return rc;
}

/****************************************************/
/*	cl_exe_scr_file_init							*/
/*  : proc	: EXECR}hsĂproc	*/
/****************************************************/
int cl_exe_scr_file_init(name,procname,leaf0,proc,nam_pos)
char   *name;
char   *procname;
Leaf   *leaf0;
ProcCT *proc;
int    nam_pos;
{
	ScrPrCT *scrprct;
	ScrPrCT *scrprctlru;
	parmList *prmp,**pprmp;
	ParList2 parl;
	M_FILE *stdiow[4];
	char *scrname,*sckind;
	int rc,pos,sk_len,iOPT_TRYPASS,parmnum,reset,rc1;
	condList *y;

	if (!(scrname = cl_set_script_name_extension(name,strlen(name)))) return -1;
	_print_script_start(scrname);

	y = &CLcList;
	/* 2022.5.8 */
	memset(stdiow,0,sizeof(stdiow));
	memset(&parl,0,sizeof(ParList2));
	reset = 0;
	/* 2021.8.18 */
	if (leaf0 && proc) {
		pprmp = &leaf0->cmd.prmp[nam_pos+1];
		parmnum = leaf0->cmd.prmnum - (nam_pos+1);
		if ((rc=cl_set_exec_parm(pprmp,parmnum,proc)) < 0) return rc;
	}

	if (scrprctlru=cl_lru_scr_src(tpLruScrHead,scrname)) {	/* LbVɂ邩ׂ */
DEBUGOUTL1(110,"cl_exe_scr_file_init: %s is found in cache",scrname);
		if (!(scrprct=cl_mk_lk_scr_pr_ct(NULL))) {
			return ECL_SYSTEM_ERROR;
		}
/*
printf("cl_exe_scr_file_init: cache hit\n");
*/
DEBUGOUTL2(110,"cl_exe_scr_file_init: scrprct=%08x leaf0=%08x",scrprct,leaf0);
		scrprct->ConstCt = NULL;
		scrprct->TreeTop = scrprctlru->TreeTop;
		scrprct->LeafConstCt = scrprctlru->LeafConstCt;
		scrprct->pId = scrprctlru->pId;
		scrprct->fullname = scrprctlru->fullname;
		scrprct->sc_pFlag = scrprctlru->sc_pFlag;
	}
	else {
		scrprct = cl_mk_scr_and_reg(y,tpLruScrHead,NULL,scrname);
		if (!scrprct) return ECL_SYSTEM_ERROR;
		if (!cl_mk_lk_scr_pr_ct(scrprct)) { /* Make Linked Script Control Table */
			const_ct_clear(CLcList.ConstCt);
			CLcList.ConstCt = NULL;
			cl_scr_clear(scrprct);
			return ECL_SYSTEM_ERROR;
		}
DEBUGOUTL2(110,"cl_exe_scr_file_init: scrprct=%08x leaf0=%08x",scrprct,leaf0);
	}

	/* 2021.8.18 */
	/* 2022.5.8 */
	rc = cl_exe_scr_set_up(y,procname,leaf0,proc,scrprct,stdiow,&parl,reset);
	/* 2021.8.25 */
/*
printf("cl_exe_scr_file_init: rc=%d try_level=%d\n",rc,pGlobTable->try_level);
*/
	scrprct->try_level_save = pGlobTable->try_level;
	if (!rc && leaf0 && pGlobTable->try_level>0) {
		iOPT_TRYPASS = cl_get_option(7,0) & 0x08;
		prmp = leaf0->cmd.prmp[nam_pos-1];
		sckind = prmp->prp;
		sk_len = prmp->prmlen;
		pos = akxnskipto(sckind,sk_len,":") + 1;
/*
printf("cl_exe_scr_file_init: pos=%d sk_len=%d sckind=[%s]\n",pos,sk_len,sckind);
*/
		if (pos < sk_len) {
			sckind += pos;
/*
printf("cl_exe_scr_file_init: try_level=%d option=[%s]\n",pGlobTable->try_level,sckind);
*/
			if (!stricmp(sckind,D_EX_OPT_NOTRYPASS)) iOPT_TRYPASS = 0;
			else if (!stricmp(sckind,D_EX_OPT_TRYPASS)) iOPT_TRYPASS = 1;
		}
/*
printf("cl_exe_scr_file_init: iOPT_TRYPASS=%d\n",iOPT_TRYPASS);
*/
		if (!iOPT_TRYPASS) pGlobTable->try_level = 0;
	}
#if 1	/* 2024.3.18 */
	if (rc) {
		if (cl_er_lk_scr_pr_ct() == -1) rc1 = ECL_SYSTEM_ERROR;
DEBUGOUTL2(110,"cl_exe_scr_file_init:Exit rc=%d rc1=%d",rc,rc1);
	}
#endif
	return rc;
}

/********************************************/
/*	cl_mk_scr_and_reg						*/
/********************************************/
ScrPrCT *cl_mk_scr_and_reg(y,tpLSH,scrct,scrname)
condList *y;
tdtLruScrHead *tpLSH;
ScrPrCT *scrct;
char *scrname;
{
	ScrPrCT *scrprct=NULL;
	ProcCT  *procct;
	Leaf    *leaf,*leafTop;
	int     rc;
	char    *p;
/*
printf("cl_mk_scr_and_reg: scrname=[%s]\n",scrname);
*/
DEBUGOUTL2(110,"cl_mk_scr_and_reg:Enter scrct=%08x scrname=[%s]",scrct,scrname);

	if (!(y->ConstCt=cl_const_ct_new())) {
		ERROROUT("Malloc ConstCt");
		return NULL;
	}

/*	CLcList.mcat = &CLcList_mcat;	*/

	rc = cl_lex_syn(y,scrname); /* Execute Lexial Analysis & Syntax Analysis */

DEBUGOUTL1(110,"cl_mk_scr_and_reg: cl_lex_syn rc=%d",rc);

	if ((rc != NormalEnd) || !(leafTop = search_top_leaf(y))) {
		goto Err;
	}
	if (scrct) {
		scrprct = scrct;
		memset(scrprct,0,sizeof(ScrPrCT));
	}
	else {
		scrprct = cl_mk_scr_pr_ct(); /* Make Script Control Table */
		if (!scrprct) goto Err;
	}
	scrprct->TreeTop = leafTop;
	scrprct->ConstCt = y->ConstCt;
	scrprct->sc_pFlag  |= y->option & D_SCRPT_NEW_LEX;

	y->ConstCt = NULL;
	y->clstcb->TopStack = NULL;	/* Ao */
	if (!(scrprct->pId=cl_const_ct_malloc(scrprct->ConstCt,strlen(scrname)+1))) {
		goto Err;
	}
	strcpy(scrprct->pId,scrname);
	p = y->fullname;
	if (!(scrprct->fullname=cl_const_ct_malloc(scrprct->ConstCt,strlen(p)+1))) {
		goto Err;
	}
	strcpy(scrprct->fullname,p);
	PRINTOUTL1(10,"***** Path = %s",p);
	scrprct->LeafConstCt = scrprct->ConstCt;

DEBUGOUTL2(110,"cl_mk_scr_and_reg: scrprct=%08x LeafConstCt=%08x",scrprct,scrprct->LeafConstCt);

	rc = cl_lru_scr_reg(tpLSH,scrprct,p);	/* LbVɓo^ */
	if (rc < 0) goto Err;
	else if (rc != C_NO_ENTRY)  {
		scrprct->ConstCt = NULL;
DEBUGOUTL1(110,"cl_mk_scr_and_reg : %s is cached now.",scrname);
	}
	return scrprct;
 Err:
	if (!scrct && scrprct) {
		scrprct->ConstCt = NULL;
		cl_scr_clear(scrprct);
	/*	Free(scrprct);	*/
	}
	const_ct_clear(y->ConstCt);
	y->ConstCt = NULL;
	y->clstcb->TopStack = NULL;
	return NULL;
}

/********************************************/
/*	_set_node_path_sub						*/
/********************************************/
int _set_node_path_sub(ProcIndex,leaf,argv0,nodeleaf,im)
XHASHB *ProcIndex;
Leaf  *leaf;
char  *argv0[];
Leaf  *nodeleaf;
int im;
{
	int id,len,flg,n0,n,len0,pos,ln,im1,im2,rc;
	long iha;
	char name[128],*np,buf[256],*path0,*path,*p,*argv[2];
	uchar *up0,*up;
	parmList *parmp;
	GXObject *pbxObj;
	Leaf *la[2],*pla;

DEBUGOUTL4(110,"_set_node_path_sub:Enter: ProcIndex=%08x leaf=%08x argv0[0]=[%s] im=%d",ProcIndex,leaf,nval1(argv0[0]),im);

	rc = 0;
	if (leaf) {
		id = leaf->cmd.cid;

DEBUGOUTL1(130,"_set_node_path_sub: node=[%s]",cl_gets_cmd_name(id));

		if (im) {
			im1 = im;
			im2 = im;
		}
		else {
			im1 = D_OPT_ALC_SCR;
			im2 = D_OPT_ALC_LEAF;
		}
		path = path0 = argv0[0];
		argv[1] = up0 = argv0[1];
		if ((id==C_NODE_SCRIPT || id==C_NODE_IMPORT) && leaf->leftleaf) {
			nodeleaf = leaf;
		}
		else if (id==C_PROC || id==C_FUNCTION/* || id==C_CLASS*/) {
			parmp = leaf->cmd.prmp[0];
			if (id == C_PROC) np = "P:";
			else if (id == C_FUNCTION) np = "F:";
			else np = "C:";
			strcpy(name,np);
			strcat(name,parmp->prp);
			if (path && *path) {
				ln = strlen(name);
				len = strlen(path) + ln + 2;
				if (len >= sizeof(buf)) return -1;
				sprintf(buf,"%s.%s",path,name);
				path = buf;
				len0 = up0[0];
				n0 = up0[len0+1];
				n = n0 + 1;
DEBUGOUTL3(110,"_set_node_path_sub: im1=%d len=%d n=%d",im1,len,n);
#if 1	/* 2023.11.3 */
				if (!(up=(uchar *)cl_opt_malloc(im1,len+2*n+3))) return ECL_MALLOC_ERROR;
#else
				if (!(up=(uchar *)cl_scr_malloc(len+2*n+3))) return ECL_MALLOC_ERROR;
#endif
				up[0] = len;
				memcpy(up+1,buf,len);
				up[len] = '.';
				up[len+1] = n;
				memcpy(up+len+2,up0+len0+2,2*n0);
				up[len+2+2*n0] = len0 + 1;
				up[len+2+2*n0+1] = ln;
				up[len+2+2*n0+2] = '\0';
				argv[1] = (char *)up;
			}
			else {
				ln = strlen(name);
				len = ln + 1;
				path = name;
				n0 = 0;
				n = 1;
DEBUGOUTL2(180,"_set_node_path_sub: im1=%d len=%d",im1,len);
#if 1	/* 2023.11.3 */
				if (!(up=(uchar *)cl_opt_malloc(im1,len+2+3))) return ECL_MALLOC_ERROR;
#else
				if (!(up=(uchar *)cl_scr_malloc(len+2+3))) return ECL_MALLOC_ERROR;
#endif
				up[0] = len;
				memcpy(up+1,name,ln);
				up[len] = '.';
				up[len+1] = n;
				up[len+2] = 1;
				up[len+2+1] = ln;
				up[len+2+2] = '\0';
				argv[1] = (char *)up;
/*
DEBUGOUTL5(130,"_set_node_path_sub: up=%d [%s] %d %d %d",up[0],strname(up+1,ln+1),up[len+1],up[len+2],up[len+3]);
DEBUGOUTL1(180,"_set_node_path_sub: up=%08x",up);
*/
			}

DEBUGOUTL4(130,"_set_node_path_sub: nodeleaf=%08x leaf=%08x path0=[%s] path=[%s]",nodeleaf,leaf,path0,path);

			flg = 0;
			if (!strcmp(parmp->prp,"main")) {
				if (nodeleaf) flg = nodeleaf->pFlag & D_LEAF_INEFFECTIVE;
			}
#if 1	/* 2023.12.7 */
			if (ProcIndex && !flg) {
#else
			if (!flg) {
#endif
				if ((iha=akxs_xhash2(ProcIndex,'R',up,&pla)) < 0) {
DEBUGOUTL1(130,"_set_node_path_sub: set nodeleaf & cur.leaf iha=%d",iha);
/*
printf("_set_node_path_sub: pla[0]=%08x pla[1]=%08x\n",pla[0],pla[1]);
*/
					return iha;
				}
				else if (!iha) {
					la[0] = leaf;
					la[1] = nodeleaf;
					pos = akxs_xhash2(ProcIndex,'S',up,la);

DEBUGOUTL1(130,"_set_node_path_sub: set nodeleaf & cur.leaf i=%d",pos);

				}
			}
/*
DEBUGOUTL1(130,"_set_node_path_sub: parmp->bxob=%08x",parmp->bxobj);
*/
			if (!(pbxObj=parmp->bxobj)) {
				len = sizeof(GXObject) + sizeof(char **) + strlen(path) + 1;
#if 1	/* 2023.11.3 */
				if (!(p=cl_opt_malloc(im2,len))) return ECL_MALLOC_ERROR;
#else
				if (!(p=cl_leaf_malloc(len))) return ECL_MALLOC_ERROR;
#endif
				pbxObj = (GXObject *)p;
				memset(pbxObj,0,sizeof(GXObject));
				parmp->bxobj = pbxObj;
				p += sizeof(GXObject);
				pbxObj->da = (char **)p;
				pbxObj->da[0] = p + sizeof(char **);
				strcpy(pbxObj->da[0],path);
				pbxObj->nda = 1;	/* add 2024.3.4 */
			}
		}
/*
printf("_set_node_path_sub: path=[%s]\n",nval1(path));
*/
		argv[0] = path;
		if (leaf->leftleaf) {
			rc = _set_node_path_sub(ProcIndex,leaf->leftleaf,argv,nodeleaf,im);
		}
		if (!rc && leaf->rightleaf) {
			rc = _set_node_path_sub(ProcIndex,leaf->rightleaf,argv0,nodeleaf,im);
		}
	}

DEBUGOUTL1(130,"_set_node_path_sub:Return: node=[%s]",cl_gets_cmd_name(id));

	return rc;
}

/********************************************/
/*	_set_node_path							*/
/********************************************/
int _set_node_path(scrct,leaf,argv0,nodeleaf)
ScrPrCT *scrct;
Leaf  *leaf;
char  *argv0[];
Leaf  *nodeleaf;
{
	return _set_node_path_sub(scrct->ProcIndex,leaf,argv0,nodeleaf,0);
}

/********************************************************/
/*	cl_exe_scr_set_up									*/
/*  : proc		: EXECR}hsĂproc	*/
/*		  scrprct	: sSCRIPTScrCt				*/
/********************************************************/
/* 2022.5.8 */
int cl_exe_scr_set_up(y,procname,leaf0,proc,scrprct,stdiow,parl,reset)
condList *y;
char *procname;
Leaf    *leaf0;
ProcCT  *proc;
ScrPrCT *scrprct;
FILE *stdiow[];
ParList2 *parl;
int reset;
{
	int  rc,i,f,parmnum,pflag2,rc1;
	char *exprocname,*argv[2],*p;
	Leaf*leaf;
	ScrPrCT	*pre;
	FILE *fp;
	parmList **pprmp;
	tdtREDIRECT *red,*redscr;

DEBUGOUTL3(110,"cl_exe_scr_set_up:Enter proc=%08x scrprct=%08x reset=%08x",proc,scrprct,reset);

	if (redscr = scrprct->redirect) {
		redscr->stdio[0] = m_stdin;
		redscr->stdio[1] = m_stdout;
		redscr->stdio[2] = m_stderr;
		redscr->stdio[3] = NULL;
		redscr->HereDoc_nm = NULL;
	}
	mem_set_addr(stdiow,NULL,4);
	parl->par = NULL;
	parl->parlen = 0;
	if (leaf0) {
		/* 2021.8.18 */
		rc = cl_scparmset(proc,scrprct,stdiow,parl);
	}
	else {
		rc = cl_parameter_set();
	}
	if (rc) goto ErLkScr;
#if 0	/* 2023.12.7 */
	rc = ECL_MALLOC_ERROR;
	if (!(scrprct->ProcIndex = akxs_xhash_new2(0,10,7,sizeof(Leaf *)*2))) goto ErLkScr;
#if 1	/* 2023.11.3 */
	scrprct->ProcIndex2 = NULL;
#endif
#endif
	if (CLcommon.dbgopt[1] & 0x01) {
		col_leaf(scrprct);
		if (!(CLcommon.dbgopt[1] & 0x02)) {
			rc = ECL_EX_EXEC_TREE;
			goto ErLkScr;
		}
	}
#if 1	/* 2023.12.7 */
	rc = ECL_MALLOC_ERROR;
	if (!(scrprct->ProcIndex = akxs_xhash_new2(0,10,7,sizeof(Leaf *)*2))) goto ErLkScr;
#if 1	/* 2023.11.3 */
	scrprct->ProcIndex2 = NULL;
#endif
#endif
	rc = 0;
	argv[0] = "";
	argv[1] = NULL;
	if ((rc=_set_node_path(scrprct,scrprct->TreeTop,argv,NULL)) < 0) goto ErLkScr;
	/*--------------*/
	/*--- on     ---*/
	/*--------------*/
	if (rc = cl_process_on(scrprct)) {
		ERROROUT("cl_exe_scr_set_up: Error occured ON condition Process");
		goto ErLkScr;
	}
	if (procname && *procname) exprocname = procname;
	else exprocname = "main";
	rc = cl_execute_scr_proc(NULL,0,NULL,scrprct,exprocname);
	if (rc < 0) goto ErLkScr;
	if (leaf0 && proc) {
		/* Need Parameter Set process */
		if (rc = cl_prparmset(/*leaf0,*/proc,exprocname)) {
			if (cl_er_lk_proc_ct() == -1) return ECL_SYSTEM_ERROR;
			else if(rc == -2) {
				if (cl_er_lk_scr_pr_ct() == -1) return ECL_SYSTEM_ERROR;
			}
			return ECL_EX_EXEC;
		}
	}
DEBUGOUTL1(110,"cl_exe_scr_set_up:Exit rc=%d",rc);
	return rc;

  ErLkScr:
#if 0	/* 2024.3.18 */
	rc1 = 0;
	if (cl_er_lk_scr_pr_ct() == -1) rc1 = ECL_SYSTEM_ERROR;
DEBUGOUTL2(110,"cl_exe_scr_set_up:Exit rc=%d rc1=%d",rc,rc1);
#endif
	return rc;
}

/********************************************/
/*	cl_mk_scr_mem_and_reg					*/
/********************************************/
ScrPrCT *cl_mk_scr_mem_and_reg(y,mem,len)
condList *y;
char *mem;
int  len;
{
	tdtInfoParm InfoParm;
	SSP_S ssp;
	ScrPrCT *scrprct;
	Leaf    *leafTop;
	int     rc,pos;

	if (!(y->ConstCt=(ConstantCt *)cl_const_ct_new())) {
		ERROROUT("Malloc ConstCt");
		return NULL;
	}
	y->ConstCt->cct_top = NULL;
	y->ConstCt->cct_cur = NULL;

	if (*mem == '{') {
		mem++;
		len--;
	}
	if (mem[len-1] == '}') {
		len--;
		mem[len] = '\0';
	}
	ssp.sp = 0;
	InfoParm.pi_paux = (char *)&ssp;
	InfoParm.pi_dlen = len;
	InfoParm.pi_data = mem;
	InfoParm.pi_scale = 0;
	y->fp = (FILE *)&InfoParm;
	y->line = 0;
	y->fullname = y->fname;
	y->option |= D_SCRPT_MEMORY;
	y->clstcb->TopStack = NULL;
	rc = cl_lex(y);
	if ((rc != NormalEnd) || !(leafTop = search_top_leaf(y))) {
		goto Err;
	}
	scrprct = cl_mk_scr_pr_ct(); /* Make Script Control Table */
	if (!scrprct) goto Err;
	scrprct->TreeTop = leafTop;
	scrprct->ConstCt = y->ConstCt;
	scrprct->sc_pFlag |= (y->option & D_SCRPT_NEW_LEX);

	y->ConstCt = NULL;
	y->clstcb->TopStack = NULL;
	scrprct->pId = y->fname;

	scrprct->LeafConstCt = scrprct->ConstCt;
	scrprct->ConstCt = NULL;
	return scrprct;
 Err:
	const_ct_clear(y->ConstCt);
	y->ConstCt = NULL;
	y->clstcb->TopStack = NULL;
	return NULL;
}

/********************************************/
/*	cl_exe_scr_mem_init						*/
/********************************************/
int cl_exe_scr_mem_init(sc_nam,pr_nam,leaf0,proc,nam_pos)
ParList *pr_nam,*sc_nam;
int  nam_pos;
Leaf    *leaf0;
ProcCT  *proc;
{
	ScrPrCT *scrprct;
	char *mem,*proc_name;
	int  len,parmnum,rc;
	parmList **pprmp;
	ParList2 parl;
	FILE *stdiow[4];
	condList *y;

DEBUGOUTL3(110,"cl_exe_scr_mem_init:Enter leaf0=%08x proc=%08x nam_pos=%d",leaf0,proc,nam_pos);

	y = &CLcList;
	errmsg_clear();
	_print_script_start(y->fname);

	proc_name = pr_nam->par;
	scrprct = cl_mk_scr_mem_and_reg(y,sc_nam->par,sc_nam->parlen);
	if (!scrprct) return ECL_SYSTEM_ERROR;
	if (!cl_mk_lk_scr_pr_ct(scrprct)) { /* Make Linked Script Control Table */
		const_ct_clear(CLcList.ConstCt);
		CLcList.ConstCt = NULL;
		cl_scr_clear(scrprct);
		return ECL_SYSTEM_ERROR;
	}
	if (proc_name) mem = proc_name;
	else mem = "";
DEBUGOUTL2(110,"cl_exe_scr_mem_init: scrprct=%08x proc_name=[%s]",scrprct,mem);

	/* 2022.6.16 */
	if (leaf0 && proc) {
		pprmp = &leaf0->cmd.prmp[nam_pos+1];
		parmnum = leaf0->cmd.prmnum - (nam_pos+1);
		if ((rc=cl_set_exec_parm(pprmp,parmnum,proc)) < 0) return rc;
	}
	mem_set_addr(stdiow,NULL,4);
	memset(&parl,0,sizeof(ParList2));
	return cl_exe_scr_set_up(y,proc_name,leaf0,proc,scrprct,stdiow,&parl,0);
}

/**************************************************************/
/* cl_search_src_ct                                           */
/* function; Search current Script Control Table              */
/**************************************************************/
ScrPrCT *cl_search_scr_ct()
{
	ScrPrCT *scrprct;

	/* 2021.2.5 */
	if (!(scrprct=pCLprocTable->CurScr)) {
		if (scrprct=pCLprocTable->PrCTp) {
			while (scrprct->nextScCT) scrprct = scrprct->nextScCT;
			pCLprocTable->CurScr = scrprct;
		}
	}
	return scrprct;
}

ScrPrCT *cl_search_src_ct()
{
	return cl_search_scr_ct();
}

/**************************************************************/
/* cl_search_proc_ct                                          */
/* function; Search current Proc Control Table                */
/**************************************************************/
ProcCT *cl_search_proc_ct()
{
	ScrPrCT *scrprct;
	ProcCT *proc;

	if (scrprct = cl_search_src_ct()) proc = scrprct->CurProc;
	else proc = NULL;
	pCLprocTable->CurProc = proc;
	return proc;
}

/**************************************************************/
/* cl_search_method_leaf                                      */
/* function; Search Method keyed by procname                  */
/**************************************************************/
Leaf *cl_search_method_leaf(leaf,procname,ppTopleaf,tag)
Leaf *leaf;
char *procname;
Leaf **ppTopleaf;
int  tag;
{
	Leaf    *wkleaf;
	Leaf    *retleaf,*topleaf;
	int cno,flg,cno_OK,pFlg,opt;

	if (!procname || !leaf) return NULL;
/*
printf("cl_search_method_leaf: proc=[%s] called. leaf=%08x ppTopleaf=%08x\n",
procname,leaf,ppTopleaf);
if (ppTopleaf) {
printf("cl_search_method_leaf: proc=[%s] nodeleaf=%08x\n",procname,*ppTopleaf);
}
*/
	retleaf  = NULL;
	wkleaf = leaf;
	opt = pFlg = flg = 0;
	if (pGlobTable->options[7] & 0x04) opt = AKX_ARGV_USE_ICMP;
	cno = wkleaf->cmd.cid;

	cno_OK = wkleaf->cmdtag & tag;

DEBUGOUTL5(151,"cl_search_method_leaf: proc=[%s] tag=%02x cno_OK=%02x cno=%08x [%s]",
procname,tag,cno_OK,cno,cl_gets_cmd_name(cno));

/*
printf("                  proc=[%s] cno_OK=%d\n",procname,cno_OK);
*/
/*
printf("proc=[%s]\n",wkleaf->cmd.prmp[0]->prp);
*/
	if (cno_OK && !akxs_opt_strcmp(wkleaf->cmd.prmp[0]->prp,procname,opt)) {
		if (ppTopleaf) {
			if (topleaf = *ppTopleaf) {
				pFlg = topleaf->pFlag;
				flg = pFlg & D_LEAF_INEFFECTIVE;
			}
		}

DEBUGOUTL2(151,"cl_search_method_leaf: proc=[%s] found. pFlag=%02x",procname,pFlg);

		if (!flg || akxs_opt_strcmp(procname,"main",opt)) return wkleaf;
	}
		if ((cno==C_NODE_SCRIPT || cno==C_NODE_IMPORT) && wkleaf->leftleaf) {
			if (ppTopleaf) *ppTopleaf = wkleaf;
/*{
Leaf *nodeleaf;
if (ppTopleaf) nodeleaf = *ppTopleaf;
else nodeleaf = NULL;
printf("cl_search_method_leaf: proc=[%s] cno=%08x\n",procname,cno);
printf("                       leaf=%08x ppTopleaf=%08x nodeleaf=%08x\n",
wkleaf,ppTopleaf,nodeleaf);
}*/
			retleaf = cl_search_method_leaf(wkleaf->leftleaf,procname,ppTopleaf,tag);
			if (retleaf) return retleaf;
			if (ppTopleaf) *ppTopleaf = NULL;
		}
		if (wkleaf->rightleaf) {
			retleaf = cl_search_method_leaf(wkleaf->rightleaf,procname,ppTopleaf,tag);
			if (retleaf) return retleaf;
		}
		return NULL;
}
#if 0	/* 2021.2.20 */
/********************************************/
/*	cl_search_proc_leaf						*/
/********************************************/
Leaf *cl_search_proc_leaf(leaf,procname,ppTopleaf)
Leaf *leaf;
char *procname;
Leaf **ppTopleaf;
{
	if (ppTopleaf) *ppTopleaf = NULL;
	return cl_search_method_leaf(leaf,procname,ppTopleaf,CTAG_PROC);
}
#endif
/********************************************/
/*	cl_search_func_leaf						*/
/********************************************/
Leaf *cl_search_func_leaf(leaf,procname,ppTopleaf)
Leaf *leaf;
char *procname;
Leaf **ppTopleaf;
{
	if (ppTopleaf) *ppTopleaf = NULL;
	return cl_search_method_leaf(leaf,procname,ppTopleaf,CTAG_FUNC);
}

/********************************************/
/*	cl_search_proc							*/
/********************************************/
Leaf *cl_search_proc(leaf,procname)
Leaf *leaf;
char *procname;
{
	return cl_search_method_leaf(leaf,procname,NULL,CTAG_PROC);
}

/********************************************/
/*											*/
/********************************************/
int col_leaf(scrprCT)
ScrPrCT *scrprCT;
{
	Leaf *leaf;

	if (!scrprCT) return -1;
	if (leaf=pGLprocTable->CurScr->TreeTop) {
		printf("### Global Source Area.\n");
		col_leaf_print(leaf);
		printf("\n");
	}
	if (leaf=scrprCT->TreeTop) {
		printf("### Source Area.\n");
		col_leaf_print(leaf);
		printf("\n");
	}
	return 0;
}

/********************************************/
/*											*/
/********************************************/
int col_leaf_print(leaf)
Leaf *leaf;
{
	static char s_node[2]={'A','\0'};
	char buf[10],*p,node[2],*pp;
	int cno;
 
	if (!leaf) return -1;
	node[0] = '\0';
	node[1] = '\0';
	p = cl_get_pcmd_line(leaf);
	if (!(leaf->leftleaf)) printf("*");
	if (CLcommon.dbgopt[1] & 0x04) printf("(%d)",leaf->type);
#if 1	/* 2023.8.11 */
	if (leaf->lf_label) {
		p = stradd5(leaf->lf_label,": ",p,NULL,NULL);
	}
#endif
	cl_str_conv_put(&pp,p,strlen(p));
	printf("[%s]",pp);
/*	printf(" pFlag=0x%02x",leaf->pFlag);	*/
	if ((cno=leaf->cmd.cid)==C_NODE_SCRIPT || cno==C_NODE_IMPORT)
		printf(" pFlag=0x%02x",leaf->pFlag);
	if (!(leaf->rightleaf)) {
		printf(".");
		if (!(leaf->leftleaf)) printf("\n");
	}
	else if (leaf->leftleaf) {
		node[0] = s_node[0];
		printf("->%s",node);
		s_node[0]++;
	}
	if (leaf->leftleaf) {
		printf("\n|\n");
		col_leaf_print(leaf->leftleaf);
	}

	if (leaf->rightleaf) {
		printf("\n%s-",node);
		col_leaf_print(leaf->rightleaf);
	}

	return (0);
}

/********************************************/
/*											*/
/********************************************/
tdtLruScrHead *cl_lru_scr_new(max)
int max;
{
	tdtLruScrHead *tpLSH;
#if 1	/* 2024.3.6 */
	tdtRbCtl *pLruScr;
#else
	qLruScr *pLruScr;
#endif

	if (max < LRU_SCR_MIN) max = LRU_SCR_MIN;
PRINTOUT1("cl_lru_scr_new:max=%d",max);
	if (!(tpLSH=(tdtLruScrHead *)Malloc(sizeof(tdtLruScrHead)))) {
		ERROROUT("cl_lru_scr_new:Malloc error!!");
		return NULL;
	}
	memset(tpLSH,0,sizeof(tdtLruScrHead));
#if 1	/* 2024.3.6 */
	if (!(pLruScr = akxs_list_new(sizeof(qLruScr),max))) {
#else
	if (!(pLruScr = (qLruScr *)Malloc(max*sizeof(qLruScr)))) {
#endif
		ERROROUT("cl_lru_scr_new:Malloc error!!");
		Free(tpLSH);
		return NULL;
	}
#if 0	/* 2024.3.6 */
	memset(pLruScr,0,max*sizeof(qLruScr));
#endif
	tpLSH->LruOption = 0;
	tpLSH->LruScrMax = max;
	tpLSH->LruCount = 0;
	tpLSH->tpLruScr = pLruScr;
	return tpLSH;
}

/********************************************/
/*											*/
/********************************************/
int cl_lru_scr_init(max)
int max;
{
	if (max < LRU_SCR_MIN) max = LRU_SCR_MIN;
PRINTOUT1("cl_lru_scr_init:max=%d",max);
	if (!(tpLruScrHead = cl_lru_scr_new(max))) {
		ERROROUT("cl_lru_scr_new:Malloc error!!");
		return -1;
	}
	if (!(tpLruScrHeadImp = cl_lru_scr_new(max))) {
		ERROROUT("cl_lru_scr_new:Imp:Malloc error!!");
		return -1;
	}
	tpLruScrHeadImp->LruOption |= 0x01;	/* add 2024.3.10 */
	return 0;
}

/********************************************/
/*											*/
/********************************************/
int cl_lru_scr_free(tpLSH)
tdtLruScrHead *tpLSH;
{
	if (tpLSH) {
		cl_lru_scr_all_clear(tpLSH);
		Free(tpLSH);
	}
	return 0;
}

/********************************************/
/*	fullname=NULL : node[0]ɖԂ		*/
/********************************************/
/* 2024.3.6 */
static int cl_lru_scr_srch_node(tpLSH,fullname,node)
tdtLruScrHead *tpLSH;
char *fullname;
tdtRbChain *node[];
{
	tdtRbCtl *pCt;
	tdtRbChain *pw, *pn, *pp;
	qLruScr *pLruScr;
	int i;
/*
printf("cl_lru_scr_srch_node:Enter fullname=[%s]\n",nval1(fullname));
*/
	if (!tpLSH) return -1;
	if (node) {
		node[0] = NULL;
		node[1] = NULL;
	}
	if (!(pCt = tpLSH->tpLruScr)) return -1;
	pw = pCt->rb_raddr;
	i = 0;
	pp = NULL;
	while (pw) {
		pLruScr = (qLruScr *)pw->rbc_buf;
		if (fullname) {
			if (!strcmp(pLruScr->cpfullname,fullname)) {
				if (node) {
					node[0] = pw;
					node[1] = pp;
				}
/*
printf("cl_lru_scr_srch_node:Exit found i=%d\n",i);
*/
				return i;
			}
		}
		pp = pw;
		pw = pw->rbc_next;
		i++;
	}
	if (!fullname) {
		node[0] = pp;
		node[1] = NULL;
/*
printf("cl_lru_scr_srch_node:Exit i=%d\n",i);
*/
		return i;
	}
/*
printf("cl_lru_scr_srch_node:Exit i=-1\n");
*/
	return -1;
}

/********************************************/
/*											*/
/********************************************/
static int cl_lru_scr_reg_new(scrprct,fullname,pLruScr)
ScrPrCT *scrprct;
char *fullname;
qLruScr *pLruScr;
{
	struct stat tStat;

	if (!scrprct || !fullname || !pLruScr) return -1;
	if (stat(fullname,&tStat)) return -1;

	if (!(pLruScr->cpfullname =
		cl_const_ct_malloc(scrprct->ConstCt,strlen(fullname)+1))) return -1;
	strcpy(pLruScr->cpfullname,fullname);
	pLruScr->mtime = tStat.st_mtime;
	pLruScr->ltime = time(0);
	akxe_get_msec(NULL,&pLruScr->rtime);
	pLruScr->refc  = 1;
	scrprct->sc_pFlag |= D_LEAF_CACHED;
	memcpy(&pLruScr->scrct,scrprct,sizeof(ScrPrCT));
/*
printf("cl_lru_scr_reg_new:mtime=%d ltime=%d\n",pLruScr->mtime,pLruScr->ltime);
*/
	return 0;
}

/********************************************/
/*											*/
/********************************************/
static int cl_lru_scr_reg_rep(scrprct,fullname,pLruScr)
ScrPrCT *scrprct;
char *fullname;
qLruScr *pLruScr;
{
	ScrPrCT *scrlruct;

	if (!scrprct || !fullname || !pLruScr) return -1;

	scrlruct = &pLruScr->scrct;
/*
printf("cl_lru_scr_reg_rep:fullname=[%s] pFlag=%02x\n",fullname,scrlruct->sc_pFlag);
*/
	if (!(scrlruct->sc_pFlag & D_LEAF_IMPORTMODE)) {
/*
printf("cl_lru_scr_reg_rep: scrlruct->pId=[%s] replaced.\n",scrlruct->pId);
*/
		cl_leaf_clear(scrlruct->TreeTop);
		const_ct_clear(scrlruct->ConstCt);
	}
	return cl_lru_scr_reg_new(scrprct,fullname,pLruScr);
}

/********************************************/
/*	_move_node_to_buttom					*/
/*	wm[h𖖔Ɉړ				*/
/*			pw : wm[h					*/
/*			pp : pw̑Õm[h				*/
/*				 pp=NULL : pw擪m[h	*/
/********************************************/
static int _move_node_to_buttom(pCt,pw,pp)
tdtRbCtl *pCt;
tdtRbChain *pw,*pp;
{
	tdtRbChain *pn;	/* ̃m[h */
	tdtRbChain *pb;	/* m[h */
/*
printf("_move_node_to_buttom:Enter pCt=%08x pw=%08x\n",pCt,pw);
*/
	if (!pCt || !pw) return -1;
	pb = pCt->rb_waddr;	/*  */

printf("_move_node_to_buttom: pb=%08x\n",pb);

	if (pw != pb) {		/* wm[hłȂ */
		/* wm[hXgO */
		pn = pw->rbc_next;
		if (pp) pp->rbc_next = pn;
		else   pCt->rb_raddr = pn;
		/* wm[h𖖔ɒǉ */
		pb->rbc_next = pw;
		pw->rbc_next = NULL;
		pCt->rb_waddr = pw;	/* ύX */
	}
	return 0;
}

/********************************************/
/*											*/
/********************************************/
ScrPrCT *cl_lru_scr_src_opt(tpLSH,scrname,opt)
tdtLruScrHead *tpLSH;
char *scrname;
int  opt;
{
	int i,rc;
	struct stat tStat;
	char dir[256];
	FILE *fp;
	qLruScr *pLruScr;
#if 1	/* 2024.3.6 */
	tdtRbCtl *pCt;
	tdtRbChain *pw,*pn,*pp,*node[2],*pb;
#endif
/*
printf("cl_lru_scr_src:Enter scrname=[%s] opt=%08x\n",nval1(scrname),opt);
*/
	if (!scrname) return NULL;
	if (!(fp=cl_file_open(scrname,dir))) return NULL;
/*
printf("cl_lru_scr_src:dir = %s\n",dir);
*/
	fclose(fp);
	/* 2024.3.6 */
	if ((i=cl_lru_scr_srch_node(tpLSH,dir,node)) >= 0) {
		pw = node[0];		/* m[h */
		pLruScr = (qLruScr *)pw->rbc_buf;
		pLruScr->ltime = time(0);
		akxe_get_msec(NULL,&pLruScr->rtime);
		if (!stat(akb_akb_home_add(dir),&tStat)) {
/*
printf("cl_lru_scr_src:i = %d, mtime=%d st_mtime=%d\n",i,
pLruScr->mtime,tStat.st_mtime);
*/
			if (pLruScr->mtime == tStat.st_mtime) {
				if (opt & 0x01) {
					pLruScr->refc++;
/*
printf("cl_lru_scr_src:after.refc=%d\n",pLruScr->refc);
*/
cl_printf5("cl_lru_scr_reg: LbV node=%08x %s refc=%d\n",pw,dir,pLruScr->refc,0,0);

					/* 2024.3.6 */
					/* m[h𖖔Ɉړ */
					/* 2024.3.10 */
					pp = node[1];
					if ((rc=_move_node_to_buttom(tpLSH->tpLruScr,pw,pp)) < 0) return NULL;
				}
				return &pLruScr->scrct;
			}
			else pLruScr->refc = 0;
		}
	}
	return NULL;
}

/********************************************/
/*											*/
/********************************************/
ScrPrCT *cl_lru_scr_src(tpLSH,scrname)
tdtLruScrHead *tpLSH;
char *scrname;
{
	return cl_lru_scr_src_opt(tpLSH,scrname,1);
}

/********************************************/
/*											*/
/********************************************/
int	cl_lru_scr_reg(tpLSH,scrprct,fullname)
tdtLruScrHead *tpLSH;
ScrPrCT *scrprct;
char *fullname;
{
	qLruScr *pLruScr;
	int i,i_min,t_min,rc,refc;
	struct timeval tv_min;
#if 1	/* 2024.3.6 */
	tdtRbCtl *pCt;
	tdtRbChain *pw,*pn,*pp,*node[2],*pb;
#endif

	if (!tpLSH || !scrprct || !fullname) return -1;
/*
printf("cl_lru_scr_reg: fulname=[%s]\n",fullname);
*/
	rc = 0;
#if 0	/* 2024.3.8 */
#if 1	/* 2024.3.6 */
	if (cl_lru_scr_srch_node(tpLSH,fullname,node) >= 0) {
		pw = node[0];
		pLruScr = (qLruScr *)pw->rbc_buf;
#else
	if ((i=cl_lru_scr_srci(tpLSH,fullname))>=0) {
		pLruScr = &tpLSH->tpLruScr[i];
#endif
		refc = pLruScr->refc;
/*
printf("cl_lru_scr_reg:found [%s], refc = %d\n",fullname,refc);
*/
		rc = cl_lru_scr_reg_rep(scrprct,fullname,pLruScr);
		if (!rc) pLruScr->refc = refc + 1;
	}
	else 
#endif
	if (tpLSH->LruCount<tpLSH->LruScrMax || (tpLSH->LruOption & 0x01)) {
/*
printf("cl_lru_scr_reg:LruCount = %d LruScrMax=%d\n",tpLSH->LruCount,tpLSH->LruScrMax);
*/
#if 1	/* 2024.3.6 */
		if (!(pCt = tpLSH->tpLruScr)) return -1;
		if (!(pLruScr = (qLruScr *)Malloc(sizeof(qLruScr)))) return -1;
		if ((rc = cl_lru_scr_reg_new(scrprct,fullname,pLruScr)) < 0) return rc;
		tpLSH->LruCount++;
#if 1	/* 2024.3.23 */
		if (akxs_list_set(pCt,pLruScr) <= 0) return -1;
#else
		if (!(pw = (tdtRbChain *)Malloc(sizeof(tdtRbChain)))) return -1;
		pw->rbc_buf = (char *)pLruScr;
		/* ɒǉ */
		pb = pCt->rb_waddr;	/*  */
		if (pb) pb->rbc_next = pw;
		pw->rbc_next = NULL;
		pCt->rb_waddr = pw;	/* ύX */
		if (!pCt->rb_raddr) pCt->rb_raddr = pw;
#endif

cl_printf5("cl_lru_scr_reg: ɐVKǉ node=%08x %s\n",pw,fullname,0,0,0);

#else
		if (tpLSH->LruOption & 0x01) {
			if ((rc=cl_lru_scr_expand(tpLSH,LRU_SCR_MIN)) < 0) return rc;
		}
		pLruScr = &tpLSH->tpLruScr[tpLSH->LruCount];
		if (!(rc = cl_lru_scr_reg_new(scrprct,fullname,pLruScr)))
			tpLSH->LruCount++;

cl_printf5("cl_lru_scr_reg: %dԖڂɐVKǉ node=%08x %s\n",tpLSH->LruCount,pLruScr,fullname,0,0);

#endif
	}
	else {
#if 1	/* 2024.3.6 */
		if (!(pCt = tpLSH->tpLruScr)) return -1;
		/* gpm[hT[` */
		pw = pCt->rb_raddr;		/* m[h̐擪 */
		pp = NULL;
		while (pw) {
			pLruScr = (qLruScr *)pw->rbc_buf;
			if (pLruScr->refc <= 0) break;
			pp = pw;
			pw = pp->rbc_next;
		}
		if (pw) {
			/* gpm[hėp */
			pLruScr = (qLruScr *)pw->rbc_buf;
			if ((rc=cl_lru_scr_reg_rep(scrprct,fullname,pLruScr)) < 0) return -1;
			/* gpm[hłȂ烊XgOɒǉ */
#if 1	/* 2024.3.10 */
			if ((rc=_move_node_to_buttom(pCt,pw,pp)) < 0) return rc;
#else
			pt = pCt->rb_waddr;		/* m[h̖ */
			if (pw != pt) {
				/* gpm[hXgO */
				pn = pw->rbc_next;	/* gpm[h̎̃m[h */
				if (pp) pp->rbc_next = pn;
				else pCt->rb_raddr = pn;
				pt->rbc_next = pw;		/* m[h̖ɒum[hǉ */
				pw->rbc_next = NULL;
				pCt->rb_waddr = pw;		/* ύX */
			}
#endif

cl_printf5("cl_lru_scr_reg: ɒuǉ node=%08x %s\n",pw,fullname,0,0,0);

		}
		else rc = C_NO_ENTRY;
#else
		i_min = -1;
		tv_min.tv_sec = LONG_MAX;
		tv_min.tv_usec = LONG_MAX;
		pLruScr = &tpLSH->tpLruScr[0];
		for (i=0;i<tpLSH->LruCount;i++,pLruScr++) {
/*
printf("cl_lru_scr_reg:i=%d refc=%d rtime=%d %d tv_min=%d %d\n",
i,pLruScr->refc,pLruScr->rtime.tv_sec,pLruScr->rtime.tv_usec,tv_min.tv_sec,tv_min.tv_usec);
*/
			if (!pLruScr->refc && akxe_timer_cmp(&pLruScr->rtime,&tv_min)<0) {
				i_min = i;
				tv_min = pLruScr->rtime;
			}
		}
		if (i_min >= 0) {
/*
printf("cl_lru_scr_reg:i_min = %d refc = %d\n",i_min,pLruScr->refc);
*/
			pLruScr = &tpLSH->tpLruScr[i_min];
			rc = cl_lru_scr_reg_rep(scrprct,fullname,pLruScr);

cl_printf5("cl_lru_scr_reg: %dԖڂu node=%08x %sx\n",i_min,pLruScr,fullname,0,0);

		}
		else rc = C_NO_ENTRY;
#endif
	}
/*
printf("cl_lru_scr_reg:Exit rc=%d\n",rc);
*/
	return rc;
}

/********************************************/
/*											*/
/********************************************/
int cl_lru_scr_era(tpLSH,scrname)
tdtLruScrHead *tpLSH;
char *scrname;
{
#if 1	/* 2024.3.6 */
	tdtRbCtl *pCt;
#endif
	qLruScr *pLruScr;
	int i, refc;
	char dir[256];
	FILE *fp;
#if 1	/* 2024.3.6 */
	tdtRbChain *pw,*node[2];
#endif

	if (!tpLSH || !scrname) return -1;
/*
printf("cl_lru_scr_era: scrname=[%s]\n",scrname);
*/
	if (!(fp=cl_file_open(scrname,dir))) return -1;
/*
printf("cl_lru_scr_era:dir = %s\n",dir);
*/
	fclose(fp);
#if 1	/* 2024.3.6 */
	if (cl_lru_scr_srch_node(tpLSH,dir,node) >= 0) {
		pw = node[0];
		pLruScr = (qLruScr *)pw->rbc_buf;
		if (pLruScr->refc>0) pLruScr->refc--;
cl_printf5("cl_lru_scr_era: gpɐݒ node=%08x %s refc=%d\n",pw,dir,pLruScr->refc,0,0);
#else
	if ((i=cl_lru_scr_srci(tpLSH,dir))>=0) {
		pLruScr = &tpLSH->tpLruScr[i];
		if (pLruScr->refc>0) pLruScr->refc--;
cl_printf5("cl_lru_scr_era: %dԖڂ𖢎gpɐݒ node=%08x %s refc=%d\n",i+1,pLruScr,dir,pLruScr->refc,0);
/*
printf("cl_lru_scr_era:i = %d, before.refc=%d\n",i,pLruScr->refc);
*/
#endif
	}
	return 0;
}

/********************************************/
/*											*/
/********************************************/
int cl_lru_scr_all_clear(tpLSH)
tdtLruScrHead *tpLSH;
{
	int i;
#if 1	/* 2024.3.6 */
	tdtRbCtl *pCt;
	tdtRbChain *pw, *pn, *pp;
	char *(*m_alloc)();
#endif
	qLruScr *pLruScr;
	tdtCONSTCT *pConstCt;
/*
printf("cl_lru_scr_all_clear: tpLSH=%08x\n",tpLSH);
*/
	if (!tpLSH) return -1;

#if 1	/* 2024.3.6 */
	pCt = tpLSH->tpLruScr;
	if (!pCt) return -1;
	m_alloc = pCt->rb_malloc;
	pw = pCt->rb_raddr;
	while (pw) {
		pLruScr = (qLruScr *)pw->rbc_buf;
#else
	if (!(pLruScr = tpLSH->tpLruScr)) return -1;

	for (i=0;i<tpLSH->LruCount;i++,pLruScr++) {
#endif
		cl_leaf_clear(pLruScr->scrct.TreeTop);
		const_ct_clear(pLruScr->scrct.ConstCt);
		pLruScr->scrct.TreeTop = NULL;
		pLruScr->scrct.ConstCt = NULL;
		pLruScr->scrct.LeafConstCt = NULL;
#if 1	/* 2024.3.6 */
		pn = pw->rbc_next;
		if (!m_alloc) Free(pw);
		pw = pn;
#endif
	}
	Free(tpLSH->tpLruScr);
	tpLSH->tpLruScr = NULL;
	return 0;
}

/************************************/
/* _imp_cmp_leaf					*/
/************************************/
static int _imp_cmp_leaf(nodeleaf,scrconst)
ScrConstCt *scrconst;
Leaf       *nodeleaf;
{
	return (scrconst->NodeLeaf == nodeleaf) ? 0 : -1;
}

/************************************/
/* cl_get_scr_const_ct				*/
/************************************/
ScrConstCt *cl_get_scr_const_ct(scrct,nodeleaf)
ScrPrCT *scrct;
Leaf    *nodeleaf;
{
	tdtRbCtl *pCt;
	ScrConstCt *scrconst;

DEBUGOUTL2(120,"cl_get_scr_const_ct: called scrct=%08x,nodeleaf=%08x",scrct,nodeleaf);
/*
if (nodeleaf) printf("cl_get_scr_const_ct: called scrct=%08x,nodeleaf=%08x\n",scrct,nodeleaf);
*/
	scrconst = NULL;
	if (scrct && nodeleaf) {
		/* 2024.3.2 */
		if (pCt=pGLprocTable->pListImport) {
			if (akxs_list_srch(pCt,nodeleaf,_imp_cmp_leaf,0)) {
				akxs_list_read(pCt,-1,&scrconst);

DEBUGOUTL1(161,"cl_get_scr_const_ct: found scrconst=%08x",scrconst);
/*
printf("cl_get_scr_const_ct: found scrconst=%08x\n",scrconst);
*/
			}
		}
	}
	return scrconst;
}

/************************************/
/* cl_set_scr_const_ct				*/
/************************************/
int cl_set_scr_const_ct(scrct,nodeleaf,impscrct)
ScrPrCT *scrct,*impscrct;
Leaf    *nodeleaf;
{
	tdtRbCtl *pCt;
	ScrConstCt *scrconst;
	int rc;

DEBUGOUTL3(120,"cl_set_scr_const_ct: called scrct=%08x,nodeleaf=%08x impscrct=%08x",scrct,nodeleaf,impscrct);
/*
if (nodeleaf) printf("cl_set_scr_const_ct: called scrct=%08x,nodeleaf=%08x impscrct=%08x\n",scrct,nodeleaf,impscrct);
*/
	rc = 0;
	if (scrct && nodeleaf) {
		/* 2021.8.18 */
		/* 2024.3.2 */
		if (!impscrct) return -1;
		if (scrconst = cl_get_scr_const_ct(impscrct,nodeleaf)) {
			scrct->ConstCt     = scrconst->ConstCt;
			scrct->LeafConstCt = scrconst->LeafConstCt;

DEBUGOUTL1(120,"cl_set_scr_const_ct: LeafConstCt=%08x",scrconst->LeafConstCt);
/*
printf("cl_set_scr_const_ct: LeafConstCt=%08x\n",scrconst->LeafConstCt);
*/
			rc = 1;
		}
	}
	return rc;
}
